    nomainwin
    notice "Instructions"+chr$(13)+_
        "Select verticies of a polygon with your mouse."+chr$(13)+_
        "Don't close the polygon... The program will do this."+chr$(13)+_
        "Choose a method for area calculation and see what happens."

    dim pointX(100)
    dim pointY(100)
    dim TrapArea(100)
    pointCount = 0
    WindowWidth = 550
    WindowHeight = 410
    UpperLeftX = 1
    UpperLeftY = 64
    graphicbox #main.gb, 5, 12, 395, 355
    button #main.default, "Calculate Area (Math)", [calculate], UL, 405, 12, 125, 25
    button #main.pixel, "Calculate Area (Pixel)", [calculate2], UL, 405, 42, 125, 25
    button #main.clear, "Clear Polygon", [clear], UL, 405, 72, 125, 25
    button #main.about, "About", [about], UL, 405, 312, 125, 25
    button #main.quit, "Quit", [quit], UL, 405, 342, 125, 25
    statictext #main.x, "x:",405, 100, 25, 25
    statictext #main.y, "y:",405, 130, 25, 25
    statictext #main.a, "MathArea:",405, 160, 75, 25
    statictext #main.b, "PixArea:",405, 200, 75, 25
    statictext #main.xPos, "x",445, 100, 125, 25
    statictext #main.yPos, "y",445, 130, 125, 25
    statictext #main.area, "MathArea:",470, 160, 125, 25
    statictext #main.area2, "PixArea:",470, 200, 125, 25
    open "Polygon Area Demo" for window as #main
    #main.gb "down;fill white; flush"
    #main "font ms_sans_serif 0 16"
    #main "trapclose [quit]"
    #main.gb "when leftButtonDown [markPoint]"
    #main.gb "when mouseMove [mouseMoved]"
    #main.gb "color black;backcolor red;down;"

    hw = hwnd(#main.gb)

    CallDll #user32, "GetDC",_
        hw as long,_  'handle of graphic box
        hdc as long   'returns the handle of the Device Context

[main.inputLoop]   'wait here for input event
    wait

[mouseMoved]
    x = MouseX
    y = MouseY
    #main.xPos x
    #main.yPos y
    wait

[markPoint]
    pointCount=pointCount+1
    pointX(pointCount) = MouseX
    pointY(pointCount) = MouseY
    if pointCount > 1 then
        #main.gb "line ";pointX(pointCount-1);" ";pointY(pointCount-1);" ";pointX(pointCount);" ";pointY(pointCount);
    end if
    #main.gb "place ";pointX(pointCount);" ";pointY(pointCount);";circlefilled 2";
    #main.gb "place ";pointX(pointCount)+5;" ";pointY(pointCount);";\";pointX(pointCount);", ";pointY(pointCount)
    wait

[clear]
    redim pointX(100)
    redim pointY(100)
    redim TrapArea(100)
    pointCount = 0
    #main.gb "cls"
    #main.gb "when leftButtonDown [markPoint]"
    #main.gb "when mouseMove [mouseMoved]"
    #main.gb "color black;backcolor red;down;"
    wait

[calculate]   'Greene's Theorem area calculation
    pointCount = pointCount+1
    pointX(pointCount) = pointX(1)
    pointY(pointCount) = pointY(1)
    #main.gb "line ";pointX(pointCount-1);" ";pointY(pointCount-1);" ";pointX(pointCount);" ";pointY(pointCount);
    for i = 1 to pointCount-1
        x1 = pointX(i)
        x2 = pointX(i+1)
        y1 = pointY(i)
        y2 = pointY(i+1)
        TrapArea(i) = (x2 - x1)*y1 + (1/2)*(x2 - x1)*(y2 - y1)
    next i
    x1 = pointX(pointCount)
    y1 = pointY(pointCount)
    x2 = pointX(1)
    y2 = pointY(1)
    TrapArea(pointCount) = (x2 - x1)*y1 + (1/2)*(x2 - x1)*(y2 - y1)
    TotalArea = 0
    For i = 1 to pointCount
        TotalArea = TotalArea + TrapArea(i)
    Next i
    #main.area abs(TotalArea)
    wait

[calculate2]   'Pixel area approximation
    #main.gb "when mouseMove"
    maxX = 0
    minX = 50000
    maxY = 0
    minY = 50000
    #main.gb "cls;size 1"
    for a = 1 to pointCount
        if a < pointCount then #main.gb "down;line ";pointX(a);" ";pointY(a);" ";pointX(a+1);" ";pointY(a+1);
        if pointX(a) > maxX then maxX = pointX(a)
        if pointY(a) > maxY then maxY = pointY(a)
        if pointX(a) < minX then minX = pointX(a)
        if pointY(a) < minY then minY = pointY(a)
    next a
    #main.gb "down;line ";pointX(pointCount);" ";pointY(pointCount);" ";pointX(1);" ";pointY(1);
    gosub [getInside]
    #main.gb "backcolor black"
    temp = Paint(hw,xPaint,yPaint)
    for y = minY to maxY
        #main.gb "color white"
        setColor = 0
        lastColor = 9999
        for x = minX to maxX
          CallDll #gdi32, "GetPixel",_
            hdc as long,_        'device context of window or control
            x as long,_          'X location of pixel questioned
            y as long,_          'Y locattion of pixel questioned
            actualColor as long  'color of pixel
        if actualColor = 0 then
                setColor = 1
                #main.gb "color green"
            else
                setColor = 0
                #main.gb "color white"
        end if
        #main.gb "set ";x;" ";y
        area = area + setColor
        lastColor = actualColor
        next x
    next y
    #main.area2 area
    wait

[getInside]
    notice "Click somewhere within the polygon, please"
    #main.gb "when leftButtonDown [getPoint]"
    wait

[getPoint]
    xPaint = MouseX
    yPaint = MouseY
    return

[about]   'Perform action for the button named 'about'
    wait

[quit] 'End the program
    CallDll #user32, "ReleaseDC",_
        hw as long,_   'handle of graphic box
        hdc as long,_  'dc from GetDC
        result as long 'returns nonzero if successful

    close #main
    end

Function Paint(hw,x,y)
    CallDll #user32, "GetDC",_
        hw as long,_  'handle of graphic box
        hDC as long   'returns the handle of the Device Context
        wFillType=_FLOODFILLBORDER
        crColor=0 'color of border=black
    calldll #gdi32, "FloodFill",_
        hDC As Long,_ 'device context
        x As Long,_ 'x location to start filling
        y As Long,_ 'y location to start filling
        crColor As Long,_ 'long color value of border, or color to replace
        Paint As boolean 'nonzero if successfull
    CallDll #user32, "ReleaseDC",_
        hw as long,_   'handle of graphic box
        hDC as long,_  'dc from GetDC
        result as long 'returns nonzero if successful
End Function
